
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Sysimage.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::sesame;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Sysimage::packageName  = string ("com.redhat.sesame");
string  Sysimage::className    = string ("sysimage");
uint8_t Sysimage::md5Sum[MD5_LEN]   =
    {0x73,0xa9,0xff,0xc5,0x24,0x1c,0xcc,0x9f,0x6b,0xf0,0x19,0xf2,0xe9,0xb3,0xd1,0x47};

Sysimage::Sysimage (ManagementAgent*, Manageable* _core, const ::qpid::types::Uuid& _uuid) :
    ManagementObject(_core),uuid(_uuid)
{
    
    osName = "";
    nodeName = "";
    release = "";
    version = "";
    machine = "";
    distro = "";
    memTotal = 0;
    swapTotal = 0;
    memFree = 0;
    swapFree = 0;
    loadAverage1Min = 0.;
    loadAverage5Min = 0.;
    loadAverage10Min = 0.;
    procTotal = 0;
    procRunning = 0;


    // Optional properties start out not-present
    for (uint8_t idx = 0; idx < 1; idx++)
        presenceMask[idx] = 0;


}

Sysimage::~Sysimage ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Sysimage::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Sysimage::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (9); // Config Element Count
    buf.putShort       (7); // Inst Element Count
    buf.putShort       (0); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "uuid";
    ft[TYPE] = TYPE_UUID;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "UUID of System Image";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "osName";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Operating System Name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "nodeName";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Node Name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "release";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "version";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "machine";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "distro";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 1;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "memTotal";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "kByte";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "swapTotal";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "kByte";
    buf.putMap(ft);


    // Statistics
    ft.clear();
    ft[NAME] = "memFree";
    ft[TYPE] = TYPE_U32;
    ft[UNIT] = "kByte";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "swapFree";
    ft[TYPE] = TYPE_U32;
    ft[UNIT] = "kByte";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "loadAverage1Min";
    ft[TYPE] = TYPE_FLOAT;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "loadAverage5Min";
    ft[TYPE] = TYPE_FLOAT;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "loadAverage10Min";
    ft[TYPE] = TYPE_FLOAT;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "procTotal";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "procRunning";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);


    // Methods

    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Sysimage::getKey() const
{
    std::stringstream key;

    key << uuid;
    return key.str();
}



void Sysimage::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["uuid"] = ::qpid::types::Variant(::qpid::types::Uuid((uuid).data()));
    _map["osName"] = ::qpid::types::Variant(osName);
    _map["nodeName"] = ::qpid::types::Variant(nodeName);
    _map["release"] = ::qpid::types::Variant(release);
    _map["version"] = ::qpid::types::Variant(version);
    _map["machine"] = ::qpid::types::Variant(machine);
    if (presenceMask[presenceByte_distro] & presenceMask_distro) {
        _map["distro"] = ::qpid::types::Variant(distro);
    }
    _map["memTotal"] = ::qpid::types::Variant(memTotal);
    _map["swapTotal"] = ::qpid::types::Variant(swapTotal);

    }

    if (includeStatistics) {
        instChanged = false;




    _map["memFree"] = ::qpid::types::Variant(memFree);
    _map["swapFree"] = ::qpid::types::Variant(swapFree);
    _map["loadAverage1Min"] = ::qpid::types::Variant(loadAverage1Min);
    _map["loadAverage5Min"] = ::qpid::types::Variant(loadAverage5Min);
    _map["loadAverage10Min"] = ::qpid::types::Variant(loadAverage10Min);
    _map["procTotal"] = ::qpid::types::Variant(procTotal);
    _map["procRunning"] = ::qpid::types::Variant(procRunning);


    // Maintenance of hi-lo statistics


    }
}

void Sysimage::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    bool _found;

    if ((_i = _map.find("uuid")) != _map.end()) {
        uuid = (_i->second).asUuid().data();
    }
    if ((_i = _map.find("osName")) != _map.end()) {
        osName = (_i->second).getString();
    }
    if ((_i = _map.find("nodeName")) != _map.end()) {
        nodeName = (_i->second).getString();
    }
    if ((_i = _map.find("release")) != _map.end()) {
        release = (_i->second).getString();
    }
    if ((_i = _map.find("version")) != _map.end()) {
        version = (_i->second).getString();
    }
    if ((_i = _map.find("machine")) != _map.end()) {
        machine = (_i->second).getString();
    }
    _found = false;
    if ((_i = _map.find("distro")) != _map.end()) {
        distro = (_i->second).getString();
        _found = true;
    }
    if (_found) {
        presenceMask[presenceByte_distro] |= presenceMask_distro;
    }
    if ((_i = _map.find("memTotal")) != _map.end()) {
        memTotal = _i->second;
    }
    if ((_i = _map.find("swapTotal")) != _map.end()) {
        swapTotal = _i->second;
    }

}

void Sysimage::doMethod (string&, const ::qpid::types::Variant::Map&, ::qpid::types::Variant::Map& outMap, const string&)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
